<?php
/**
 * PHP Wrapper Example
 *
 * @author Benny Baumann (BenBE) <BenBE@geshi.org>
 * @version $Id$
 * @copyright 2009-2012 by Benny Baumann
 */

include 'rrdtool.php';

$files = array(
    // Logfiles starting with oldest file to care about

    "zlib:/var/log/apache2/access.log.2.gz",
    "/var/log/apache2/access.log.1",
    "/var/log/apache2/access.log",
    );

$domains = array(
    "other",
    "localhost",

    // Needs to be filled in ...
    "example.org"
    );

//------------
if(!RRDTool::isAvailable()) {
    die("The RRDTool extension for PHP is not available to this script. Please check your configuration and make sure it is properly loaded.");
    exit;
}

$status_codes = array(
    100, 101, 102, 103, 122,

    200, 201, 202, 203, 204, 205, 206, 207,
    208, 226,

    300, 301, 302, 303, 304, 305, 306, 307,
    308,

    400, 401, 402, 403, 404, 405, 406, 407,
    408, 409, 410, 411, 412, 413, 414, 415,
    416, 417, 418,      420,      422, 423,
    424, 425, 426,      428, 429,      431,
    444, 449, 450, 499,

    500, 501, 502, 503, 504, 505, 506, 507,
    508, 509, 510, 511,
    598, 599
    );

$RRD_domain = array();

foreach($domains as $domain) {
$RRD = RRDTool::Archive();
if(!$RRD->Load("rrd/$domain.rrd")) {
    $RRD->Start = 1167609600;

    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'port80', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'port443', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );

    foreach($status_codes as $status) {
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            "status$status", RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    }

    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqGET', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqHEAD', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqOPTION', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqPOST', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqPUT', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqCOPY', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqDELETE', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqMERGE', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqPROPFIND', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqPROPPATCH', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqMKCOL', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqREPORT', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqPATCH', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqCONNECT', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'reqother', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );

    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'http09', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'http10', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'http11', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'httpother', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );

    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'ipv4', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'ipv6', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 65535
                )
            )
        );

    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'traffic', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 1000000000
                )
            )
        );

    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'trafficv4', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 1000000000
                )
            )
        );
    $RRD->addDS(
        RRDTool_DataSource::createDS(
            'trafficv6', RRD_DS_COUNTER, 600,
            array(
                RRD_PARAM_CF_MIN => 0,
                RRD_PARAM_CF_MAX => 1000000000
                )
            )
        );

    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_AVG, 0.5,
        $RRD->getPDPIC(RRD_DEFAULT_STEP),
        $RRD->getPDPIC(RRD_TIME_DAY)
        ));
    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_AVG, 0.5,
        $RRD->getPDPIC(15 * RRD_TIME_MINUTE),
        $RRD->getPDPIC(RRD_TIME_WEEK, 15 * RRD_TIME_MINUTE)
        ));
    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_AVG, 0.5,
        $RRD->getPDPIC(RRD_TIME_HOUR),
        $RRD->getPDPIC(RRD_TIME_MONTH, RRD_TIME_HOUR)
        ));
    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_AVG, 0.5,
        $RRD->getPDPIC(4 * RRD_TIME_HOUR),
        $RRD->getPDPIC(RRD_TIME_YEAR, 4 * RRD_TIME_HOUR)
        ));
    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_AVG, 0.5,
        $RRD->getPDPIC(12 * RRD_TIME_HOUR),
        $RRD->getPDPIC(5 * RRD_TIME_YEAR, 12 * RRD_TIME_HOUR)
        ));

    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_MAX, 0.5,
        $RRD->getPDPIC(15 * RRD_TIME_MINUTE),
        $RRD->getPDPIC(RRD_TIME_DAY, 15 * RRD_TIME_MINUTE)
        ));
    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_MAX, 0.5,
        $RRD->getPDPIC(RRD_TIME_HOUR),
        $RRD->getPDPIC(RRD_TIME_WEEK, RRD_TIME_HOUR)
        ));
    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_MAX, 0.5,
        $RRD->getPDPIC(4 * RRD_TIME_HOUR),
        $RRD->getPDPIC(RRD_TIME_MONTH, 4 * RRD_TIME_HOUR)
        ));
    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_MAX, 0.5,
        $RRD->getPDPIC(12 * RRD_TIME_HOUR),
        $RRD->getPDPIC(RRD_TIME_YEAR, 12 * RRD_TIME_HOUR)
        ));
    $RRD->addRRA(RRDTool_Archive::createRRACF(
        RRD_RRA_CF_MAX, 0.5,
        $RRD->getPDPIC(12 * RRD_TIME_HOUR),
        $RRD->getPDPIC(5 * RRD_TIME_YEAR, 12 * RRD_TIME_HOUR)
        ));

    $RRD->Save("rrd/$domain.rrd");
    echo rrd_error();
}
$RRD_domain[$domain] = $RRD;
}

$cnt = array();
foreach($domains as $domain) {
    $cnt[$domain] = array(
        'port80' => 0,
        'port443' => 0,

        'reqGET' => 0,
        'reqOPTION' => 0,
        'reqHEAD' => 0,
        'reqPOST' => 0,
        'reqPUT' => 0,
        'reqCOPY' => 0,
        'reqDELETE' => 0,
        'reqMERGE' => 0,
        'reqPROPFIND' => 0,
        'reqPROPPATCH' => 0,
        'reqPATCH' => 0,
        'reqMKCOL' => 0,
        'reqREPORT' => 0,
        'reqCONNECT' => 0,
        'reqother' => 0,

        'http09' => 0,
        'http10' => 0,
        'http11' => 0,
        'httpother' => 0,

        'ipv4' => 0,
        'ipv6' => 0,

        'traffic' => 0,
        'trafficv4' => 0,
        'trafficv6' => 0,
        );

    foreach($status_codes as $status) {
        $cnt[$domain]["status$status"] = 0;
    }
}

$s = 1;
$s_last = $s;

$n = 0;
$u = 0;
$t = microtime(true);

foreach($files as $logfile) {
    echo "Reading $logfile ...\n";
    if('zlib:' == substr($logfile, 0, 5)) {
        $log = gzopen(substr($logfile, 5), 'r');
    } else {
        $log = fopen($logfile, 'r');
    }

    while(!feof($log)) {
        $p = "/\[([^\]]+)\]\s+(?:[\w\.\-]+\.)??(box1.sys.ccs-baumann.de|(?:[\w\-]+\.)+\w+):(\d+)\s+([\d+\.]+|[\da-fA-F\.:]+]).*?\s+(HTTP\/\S+|-)\s+(\w+)\s+.*?\s+(\d+)\s+\d+\s+(\d+)/";
        $l = fgets($log, 16384);

        if(preg_match($p, $l, $m)) {
            $m_d = strtotime($m[1]);
            $m_h = $m[2];
            if(!isset($cnt[$m_h])) {
                while(strpos($m_h, '.') && !isset($cnt[$m_h])) {
                    $m_h = substr($m_h, strpos($m_h, '.') + 1);
                }
                if(!isset($cnt[$m_h])) {
                    $m_h = "other";
                }
            }
            $m_p = $m[3];
            $m_ip = $m[4] == '-' ? 'v4' : strpos($m[4], '.') ? 'v4' : 'v6';
            $m_t = ($m[5]=='HTTP/1.1') ? 'http11' : (
                    ($m[5]=='HTTP/1.0') ? 'http10' : (
                    ($m[5]=='HTTP/0.9') ? 'http09' :
                    'httpother'));
            $m_m = $m[6];
            if(!isset($cnt[$m_h]["req$m_m"])) $m_m = "other";
            $m_s = (int)$m[7];
            if(!in_array($m_s, $status_codes)) $m_s = 500;
            $m_io = $m[8];

            if($m_d > $s) {
                if($s_last + 30 <= $m_d) {
                    foreach($RRD_domain as $domain => $RRD) {
                        if(!$RRD->Update($s, $cnt[$domain])) {
                            break;
                        }
                        $u++;
                    }
                    $s_last = $m_d;
                }
                $s = $m_d;
            }

            $cnt[$m_h]["port$m_p"]++;
            $cnt[$m_h][$m_t]++;
            $cnt[$m_h]["ip$m_ip"]++;
            $cnt[$m_h]["status$m_s"]++;
            $cnt[$m_h]["req$m_m"]++;
            $cnt[$m_h]['traffic'] += $m_io;
            $cnt[$m_h]["traffic$m_ip"] += $m_io;
        }

        $n++;
        if(!($n%200)) {
            echo ".";
        }
        if(!($n%10000)) {
            printf("%d (%.2f Updates/sec, %d insgesamt)\n", $n, $u/(microtime(true) - $t), $u);
        }
    }

    fclose($log);
}

echo "\n\n$n lines parsed ...\n";
var_dump($cnt);

function h2ds($h) {
    return substr(preg_replace("/[^a-z0-9]/", "", $h), 0, 16);
}

?>